package proxy.nbt;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

abstract class Nbt {
	abstract void write(DataOutput output) throws IOException;
	abstract void read(DataInput input, int depth, Tracker tracker) throws IOException;
	abstract byte getId();

	static Nbt createTag(byte id) {
		switch(id) {
			case 0:
				return new NbtNull();
			case 1:
				return new NbtByte();
			case 2:
				return new NbtShort();
			case 3:
				return new NbtInt();
			case 4:
				return new NbtLong();
			case 5:
				return new NbtFloat();
			case 6:
				return new NbtDouble();
			case 7:
				return new NbtByteArray();
			case 8:
				return new NbtString();
			case 9:
				return new NbtList();
			case 10:
				return new NbtCompound();
			case 11:
				return new NbtIntArray();
			default:
				return null;
		}
	}
}
