package proxy.nbt;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

class NbtIntArray extends Nbt {
	private int[] data;

	void write(DataOutput output) throws IOException {
		output.writeInt(this.data.length);
		for(int z = 0; z < this.data.length; z++) {
			output.writeInt(this.data[z]);
		}
	}

	void read(DataInput input, int depth, Tracker tracker) throws IOException {
		tracker.read(192L);
		int len = input.readInt();
		tracker.read((long)(32 * len));
		this.data = new int[len];
		for(int z = 0; z < len; z++) {
			this.data[z] = input.readInt();
		}
	}

	byte getId() {
		return (byte)11;
	}
}
