package proxy.packet;

import java.io.IOException;

import proxy.network.StatusHandler;
import proxy.network.Packet;
import proxy.network.PacketBuffer;

public class I01PacketPong implements Packet<StatusHandler>
{
    private long clientTime;

    public I01PacketPong()
    {
    }

    public I01PacketPong(long time)
    {
        this.clientTime = time;
    }

    /**
     * Reads the raw packet data from the data stream.
     */
    public void readPacketData(PacketBuffer buf) throws IOException
    {
        this.clientTime = buf.readLong();
    }

    /**
     * Writes the raw packet data to the data stream.
     */
    public void writePacketData(PacketBuffer buf) throws IOException
    {
        buf.writeLong(this.clientTime);
    }

    /**
     * Passes this Packet on to the NetHandler for processing.
     */
    public void processPacket(StatusHandler handler)
    {
    }
}
