package proxy.packet;

import java.io.IOException;

import proxy.network.ProxyHandler.ProxyLoginHandler;
import proxy.network.Packet;
import proxy.network.PacketBuffer;

public class R01PacketEncryptionRequest implements Packet<ProxyLoginHandler>
{
    private String hashedServerId;
    private byte[] publicKey;
    private byte[] verifyToken;

    /**
     * Reads the raw packet data from the data stream.
     */
    public void readPacketData(PacketBuffer buf) throws IOException
    {
        this.hashedServerId = buf.readStringFromBuffer(20);
        this.publicKey = buf.readByteArray();
        this.verifyToken = buf.readByteArray();
    }

    /**
     * Writes the raw packet data to the data stream.
     */
    public void writePacketData(PacketBuffer buf) throws IOException
    {
        buf.writeString(this.hashedServerId);
        buf.writeByteArray(this.publicKey);
        buf.writeByteArray(this.verifyToken);
    }

    /**
     * Passes this Packet on to the NetHandler for processing.
     */
    public void processPacket(ProxyLoginHandler handler)
    {
        handler.handleEncryptionRequest(this);
    }
}
