package proxy.packet;

import java.io.IOException;

import proxy.network.ProxyHandler;
import proxy.network.Packet;
import proxy.network.PacketBuffer;

public class S0DPacketCollectItem extends EntityIdPacketClient implements Packet<ProxyHandler>
{
    private int collectedItemEntityId;

    public Packet replaceEntityId(int real, int spoofed) {
    	super.replaceEntityId(real, spoofed);
    	if(this.collectedItemEntityId == real)
    		this.collectedItemEntityId = spoofed;
    	return this;
    }

    /**
     * Reads the raw packet data from the data stream.
     */
    public void readPacketData(PacketBuffer buf) throws IOException
    {
        this.collectedItemEntityId = buf.readVarIntFromBuffer();
        this.entityId = buf.readVarIntFromBuffer();
    }

    /**
     * Writes the raw packet data to the data stream.
     */
    public void writePacketData(PacketBuffer buf) throws IOException
    {
        buf.writeVarIntToBuffer(this.collectedItemEntityId);
        buf.writeVarIntToBuffer(this.entityId);
    }

    /**
     * Passes this Packet on to the NetHandler for processing.
     */
    public void processPacket(ProxyHandler handler)
    {
        handler.handleCollectItem(this);
    }
}
